diff --git a/test/unit/commands/setup/orchestrator_test.rb b/test/unit/commands/setup/orchestrator_test.rb
new file mode 100644
index 00000000..d05a4a72
--- /dev/null
+++ b/test/unit/commands/setup/orchestrator_test.rb
@@ -0,0 +1,83 @@
+require "test_helper"
+require "hive/commands/setup"
+require "json_schemer"
+
+class HiveCommandsSetupOrchestratorTest < Minitest::Test
+  include HiveTestHelper
+
+  Result = Hive::Setup::Diagnostics::Result
+
+  def report(*results)
+    Hive::Setup::Diagnostics::Report.new(results)
+  end
+
+  def result(name, status: "ok", ownership: "external")
+    Result.new(name, status, nil, nil, ownership, "evidence", "fix #{name}")
+  end
+
+  def test_qmd_component_mode_performs_no_project_or_service_mutation
+    qmd = Struct.new(:calls) do
+      def install
+        self.calls += 1
+        Hive::Setup::QmdInstaller::Result.new("installed", "/tmp/qmd", "/tmp/qmd/bin/qmd", "qmd installed")
+      end
+    end.new(0)
+    out = StringIO.new
+
+    status = Hive::Commands::Setup.new(
+      "/not-a-project", only: "qmd", json: true, qmd_installer: qmd, stdout: out
+    ).call
+
+    assert_equal 0, status
+    assert_equal 1, qmd.calls
+    payload = JSON.parse(out.string)
+    assert_equal [ "qmd" ], payload.fetch("phases").map { |phase| phase.fetch("name") }
+    schema = JSONSchemer.schema(JSON.parse(File.read(Hive::Schemas.schema_path("hive-setup"))))
+    assert_empty schema.validate(payload).to_a
+  end
+
+  def test_external_diagnostic_failures_stop_all_mutations_but_report_every_phase
+    qmd = Object.new
+    qmd.define_singleton_method(:install) { raise "qmd bootstrap must not run before external prerequisites are fixed" }
+    diagnostics = Object.new
+    failed_report = report(result("git", status: "missing"), result("qmd", status: "missing", ownership: "hive_owned"))
+    diagnostics.define_singleton_method(:call) { failed_report }
+    out = StringIO.new
+
+    status = Hive::Commands::Setup.new(
+      "/not-a-project", json: true, diagnostics: diagnostics, qmd_installer: qmd, stdout: out
+    ).call
+
+    assert_equal 1, status
+    payload = JSON.parse(out.string)
+    assert_equal false, payload.fetch("ok")
+    phases = payload.fetch("phases")
+    assert_equal "failed", phases.find { |phase| phase.fetch("name") == "diagnostics" }.fetch("status")
+    assert_equal "skipped", phases.find { |phase| phase.fetch("name") == "project_enrollment" }.fetch("status")
+  end
+
+  def test_diagnose_only_never_calls_owned_bootstrap
+    diagnostics = Object.new
+    diagnostic_report = report(result("git"), result("qmd", status: "missing", ownership: "hive_owned"))
+    diagnostics.define_singleton_method(:call) { diagnostic_report }
+    qmd = Object.new
+    qmd.define_singleton_method(:install) { raise "diagnose-only must not write owned assets" }
+
+    out = StringIO.new
+    status = Hive::Commands::Setup.new(
+      "/not-a-project", diagnose_only: true, json: true, diagnostics: diagnostics, qmd_installer: qmd, stdout: out
+    ).call
+
+    assert_equal 1, status
+    assert_equal false, JSON.parse(out.string).fetch("ok")
+  end
+
+  def test_accepts_a_linked_git_worktree_metadata_file
+    with_tmp_dir do |dir|
+      File.write(File.join(dir, ".git"), "gitdir: /tmp/shared-worktree\n")
+      command = Hive::Commands::Setup.new(dir, diagnostics: Object.new, stdout: StringIO.new)
+
+      assert command.send(:git_repository?)
+    end
+  end
+end
diff --git a/test/unit/commands/web/service_installer_test.rb b/test/unit/commands/web/service_installer_test.rb
new file mode 100644
index 00000000..1adbac18
--- /dev/null
+++ b/test/unit/commands/web/service_installer_test.rb
@@ -0,0 +1,44 @@
+require "test_helper"
+require "hive/commands/web/service_installer"
+
+class WebServiceInstallerTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_linux_service_is_independent_and_serializes_only_safe_environment
+    with_tmp_dir do |dir|
+      hive = File.join(dir, "bin with spaces", "hive")
+      FileUtils.mkdir_p(File.dirname(hive))
+      File.write(hive, "#!/bin/sh\n")
+      FileUtils.chmod(0o755, hive)
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux", home: dir, binary_path: hive, systemctl_available: false,
+        bind: "127.0.0.1", port: 4567,
+        environment: { "HIVE_HOME" => "/tmp/hive state", "GH_TOKEN" => "secret", "HIVE_CLAUDE_BIN" => "claude" }
+      )
+
+      result = installer.install!(autostart: false)
+      body = File.read(File.join(dir, ".config/systemd/user/hive-web.service"))
+
+      assert result.success?
+      assert_includes body, "ExecStart=#{Shellwords.escape(hive)} web --bind 127.0.0.1 --port 4567"
+      assert_includes body, "Environment=HIVE_HOME=/tmp/hive\\x20state"
+      refute_includes body, "GH_TOKEN"
+      refute_includes body, "HIVE_CLAUDE_BIN"
+      refute_includes body, "hive-daemon.service"
+    end
+  end
+
+  def test_status_distinguishes_not_installed_and_running
+    with_tmp_dir do |dir|
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux", home: dir, binary_path: "/tmp/hive", systemctl_available: true,
+        runner: ->(argv) { argv.include?("is-active") }, bind: "127.0.0.1", port: 4567
+      )
+      assert_equal "not_installed", installer.lifecycle_status.fetch("status")
+
+      FileUtils.mkdir_p(File.dirname(installer.target_path))
+      File.write(installer.target_path, "unit")
+      assert_equal "running", installer.lifecycle_status.fetch("status")
+    end
+  end
+end
diff --git a/test/unit/commands/web_bind_policy_test.rb b/test/unit/commands/web_bind_policy_test.rb
new file mode 100644
index 00000000..121046e2
--- /dev/null
+++ b/test/unit/commands/web_bind_policy_test.rb
@@ -0,0 +1,42 @@
+require "test_helper"
+require "hive/web/loopback"
+
+class WebBindPolicyTest < Minitest::Test
+  def test_recognizes_only_real_ipv4_and_ipv6_loopback_listeners
+    assert Hive::Web::Loopback.listener?("127.0.0.1")
+    assert Hive::Web::Loopback.listener?("::1")
+    refute Hive::Web::Loopback.listener?("0.0.0.0")
+    refute Hive::Web::Loopback.listener?("192.168.1.10")
+  end
+
+  def test_localhost_requires_every_resolved_address_to_be_loopback
+    resolver = ->(_name) { [ "127.0.0.1", "::1" ] }
+    assert Hive::Web::Loopback.listener?("localhost", resolver: resolver)
+    refute Hive::Web::Loopback.listener?("localhost", resolver: ->(_name) { [ "127.0.0.1", "10.0.0.1" ] })
+    refute Hive::Web::Loopback.listener?("localhost", resolver: ->(_name) { [] })
+  end
+
+  def test_public_bind_requires_github_claim_flow_or_explicit_unsafe_override
+    local = Hive::Web::Loopback.policy!(bind: "127.0.0.1", config: {})
+    assert local.local_mode?
+
+    assert_raises(Hive::ConfigError) do
+      Hive::Web::Loopback.policy!(bind: "0.0.0.0", config: { "github" => { "client_id" => "" } })
+    end
+
+    owner = Hive::Web::Loopback.policy!(bind: "0.0.0.0", config: { "github" => { "client_id" => "client" } })
+    refute owner.local_mode?
+    refute owner.unsafe?
+
+    unsafe = Hive::Web::Loopback.policy!(bind: "0.0.0.0", config: {}, unsafe_no_auth: true)
+    assert unsafe.unsafe?
+  end
+
+  def test_local_trust_requires_signal_peer_and_authorized_host
+    assert Hive::Web::Loopback.trusted_request?(enabled: true, remote_ip: "127.0.0.1", host: "localhost")
+    assert Hive::Web::Loopback.trusted_request?(enabled: true, remote_ip: "::1", host: "[::1]")
+    refute Hive::Web::Loopback.trusted_request?(enabled: true, remote_ip: "10.0.0.2", host: "localhost")
+    refute Hive::Web::Loopback.trusted_request?(enabled: true, remote_ip: "127.0.0.1", host: "attacker.test")
+    refute Hive::Web::Loopback.trusted_request?(enabled: false, remote_ip: "127.0.0.1", host: "localhost")
+  end
+end
diff --git a/test/unit/gemspec_test.rb b/test/unit/gemspec_test.rb
index a4ddfc6e..d5c30de9 100644
--- a/test/unit/gemspec_test.rb
+++ b/test/unit/gemspec_test.rb
@@ -25,9 +25,8 @@ class GemspecTest < Minitest::Test
     assert_includes spec.files, "bin/hv"
   end
 
-  # The web tier is a Rails app under web/, supported only in the Docker
-  # image or a source checkout — the gem must stay a lean CLI and not
-  # package the app or its old Sinatra-era assets.
+  # The web tier is a separately signed release archive — the gem stays a
+  # lean CLI and never embeds Rails or its old Sinatra-era assets.
   def test_gem_package_excludes_the_rails_web_app
     spec = Gem::Specification.load(GEMSPEC_PATH)
 
diff --git a/test/unit/install_script_test.rb b/test/unit/install_script_test.rb
index 22515c88..01496dd5 100644
--- a/test/unit/install_script_test.rb
+++ b/test/unit/install_script_test.rb
@@ -18,4 +18,11 @@ class InstallScriptTest < Minitest::Test
 
     refute_includes script, 'mv "${gem_home}/bin/hv" "${gem_home}/shims/hv"'
   end
+
+  def test_installer_delegates_qmd_bootstrap_to_the_installed_cli
+    script = File.read(INSTALL_SCRIPT)
+
+    assert_includes script, '"$installed_bin" setup --only=qmd'
+    refute_includes script, 'npm rebuild --global --prefix "$qmd_home" better-sqlite3'
+  end
 end
diff --git a/test/unit/openclaw_skills_test.rb b/test/unit/openclaw_skills_test.rb
index eb700e97..be724f94 100644
--- a/test/unit/openclaw_skills_test.rb
+++ b/test/unit/openclaw_skills_test.rb
@@ -36,7 +36,7 @@ class OpenClawSkillsTest < Minitest::Test
     assert_equal [ "hive" ], installer.fetch("bins")
   end
 
-  def test_umbrella_skill_guides_install_init_and_cli_dispatch
+  def test_umbrella_skill_guides_install_native_setup_and_cli_dispatch
     _metadata, body = read_skill("hive")
 
     assert_includes body, "/hive setup"
@@ -55,8 +55,8 @@ class OpenClawSkillsTest < Minitest::Test
     assert_includes body, "brew install ivankuznetsov/hive/hive"
     assert_includes body, "yay -S --noconfirm --needed hive-bin"
     assert_includes body, "v0.2.0/install.sh"
-    assert_includes body, "daemon install"
-    assert_includes body, "init . --json </dev/null"
+    assert_includes body, '"${hive_cmd}" setup . --json'
+    assert_includes body, "phase envelope"
     assert_includes body, "slash-command text after `/hive` as arguments for `hive_cmd`"
     assert_includes body, '"${hive_cmd}" --help'
     assert_includes body, "Pass arguments safely"
diff --git a/test/unit/setup/diagnostics_test.rb b/test/unit/setup/diagnostics_test.rb
new file mode 100644
index 00000000..305f0239
--- /dev/null
+++ b/test/unit/setup/diagnostics_test.rb
@@ -0,0 +1,78 @@
+require "test_helper"
+require "hive/setup/diagnostics"
+
+class SetupDiagnosticsTest < Minitest::Test
+  def test_reports_machine_readable_external_and_hive_owned_checks
+    runner = lambda do |argv, **_kwargs|
+      case argv
+      when [ "ruby", "--version" ] then [ "ruby 3.4.2", "", 0 ]
+      when [ "git", "--version" ] then [ "git version 2.46.0", "", 0 ]
+      when [ "tmux", "-V" ] then [ "tmux 3.4", "", 0 ]
+      when [ "gh", "--version" ] then [ "gh version 2.60.0", "", 0 ]
+      when [ "gh", "auth", "status" ] then [ "", "Logged in", 0 ]
+      when [ "claude", "--version" ] then [ "2.2.0", "", 0 ]
+      when [ "codex", "--version" ] then [ "codex 0.126.0", "", 0 ]
+      when [ "node", "--version" ] then [ "v22.1.0", "", 0 ]
+      when [ "npm", "--version" ] then [ "10.9.0", "", 0 ]
+      when [ "qmd", "--version" ] then [ "qmd 1.2.0", "", 0 ]
+      else [ "", "", 127 ]
+      end
+    end
+
+    report = Hive::Setup::Diagnostics.new(
+      runner: runner,
+      agent_logged_in: ->(_name) { true },
+      rails_ready: -> { true },
+      sqlite_ready: -> { true },
+      platform: :linux
+    ).call
+
+    assert report.healthy?
+    assert_equal %w[claude codex gh git node npm qmd rails_bundle ruby sqlite tmux],
+                 report.results.map(&:name).sort
+    assert_equal "external", report.fetch("git").ownership
+    assert_equal "hive_owned", report.fetch("qmd").ownership
+    assert_equal "hive_owned", report.fetch("rails_bundle").ownership
+    assert_equal "ok", report.fetch("ruby").status
+    assert_equal report.to_h.fetch("checks").map { |row| row.fetch("status") },
+                 report.results.map(&:status)
+  end
+
+  def test_redacts_bounded_probe_evidence_and_keeps_fix_command
+    runner = lambda do |argv, **_kwargs|
+      case argv.first
+      when "gh" then [ "", "token=super-secret-value", 127 ]
+      when "claude" then [ "2.2.0", "", 0 ]
+      when "codex" then [ "0.126.0", "", 0 ]
+      else [ "", "token=super-secret-value", 1 ]
+      end
+    end
+    report = Hive::Setup::Diagnostics.new(
+      runner: runner,
+      agent_logged_in: ->(_name) { false },
+      rails_ready: -> { false },
+      sqlite_ready: -> { false },
+      platform: :macos
+    ).call
+
+    gh = report.fetch("gh")
+    assert_equal "missing", gh.status
+    assert_match(/brew install gh/, gh.fix_command)
+    refute_match(/super-secret-value/, gh.evidence)
+    assert_operator gh.evidence.bytesize, :<=, Hive::Setup::Diagnostics::EVIDENCE_LIMIT
+    assert_equal "unauthenticated", report.fetch("claude").status
+  end
+
+  def test_unknown_platform_is_an_actionable_error_without_running_probes
+    calls = []
+    report = Hive::Setup::Diagnostics.new(
+      runner: ->(argv, **_kwargs) { calls << argv; [ "", "", 0 ] },
+      platform: :unsupported
+    ).call
+
+    refute report.healthy?
+    assert_equal [], calls
+    assert_equal "error", report.fetch("platform").status
+    assert_match(/Linux or macOS/, report.fetch("platform").fix_command)
+  end
+end
diff --git a/test/unit/setup/qmd_installer_test.rb b/test/unit/setup/qmd_installer_test.rb
new file mode 100644
index 00000000..0e450ad0
--- /dev/null
+++ b/test/unit/setup/qmd_installer_test.rb
@@ -0,0 +1,56 @@
+require "test_helper"
+require "hive/setup/qmd_installer"
+
+class SetupQmdInstallerTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_installs_rebuilds_validates_and_links_hive_owned_qmd
+    with_xdg_home do
+      calls = []
+      runner = lambda do |argv, **_kwargs|
+        calls << argv
+        if argv.include?("install")
+          prefix = argv[argv.index("--prefix") + 1]
+          bin = File.join(prefix, "bin", "qmd")
+          FileUtils.mkdir_p(File.dirname(bin))
+          File.write(bin, "#!/bin/sh\necho qmd 1.0.0\n")
+          FileUtils.chmod(0o755, bin)
+        end
+        [ "qmd 1.0.0", "", 0 ]
+      end
+
+      result = Hive::Setup::QmdInstaller.new(runner: runner).install
+
+      assert result.ok?
+      assert_equal "installed", result.status
+      assert calls.any? { |argv| argv.values_at(0, 1, 2, 3, 5) == [ "npm", "rebuild", "--global", "--prefix", "better-sqlite3" ] },
+             "the native module must be rebuilt in the staged Hive-owned prefix"
+      assert File.symlink?(File.join(Hive::Paths.bin_home, "qmd"))
+    end
+  end
+
+  def test_never_overwrites_a_foreign_qmd_link
+    with_xdg_home do |dir|
+      foreign = File.join(dir, "foreign-qmd")
+      File.write(foreign, "#!/bin/sh\n")
+      FileUtils.chmod(0o755, foreign)
+      FileUtils.mkdir_p(Hive::Paths.bin_home)
+      File.symlink(foreign, File.join(Hive::Paths.bin_home, "qmd"))
+
+      result = Hive::Setup::QmdInstaller.new(runner: ->(_argv, **_kwargs) { [ "", "", 1 ] }).install
+
+      refute result.ok?
+      assert_equal foreign, File.readlink(File.join(Hive::Paths.bin_home, "qmd"))
+    end
+  end
+
+  def test_reports_missing_npm_without_mutating_the_filesystem
+    with_xdg_home do
+      result = Hive::Setup::QmdInstaller.new(runner: ->(_argv, **_kwargs) { [ "", "", 127 ] }).install
+
+      refute result.ok?
+      assert_equal "missing_npm", result.status
+      refute File.exist?(Hive::Setup::QmdInstaller.default_prefix)
+    end
+  end
+end
diff --git a/test/unit/web/app_bundle_test.rb b/test/unit/web/app_bundle_test.rb
new file mode 100644
index 00000000..9fc0b161
--- /dev/null
+++ b/test/unit/web/app_bundle_test.rb
@@ -0,0 +1,104 @@
+require "test_helper"
+require "digest"
+require "rubygems/package"
+require "zlib"
+require "hive/web/app_bundle"
+
+class WebAppBundleTest < Minitest::Test
+  include HiveTestHelper
+
+  def with_archive(entries)
+    with_tmp_dir do |dir|
+      archive = File.join(dir, "web.tar.gz")
+      Zlib::GzipWriter.open(archive) do |gzip|
+        Gem::Package::TarWriter.new(gzip) do |tar|
+          entries.each do |name, content|
+            if name.end_with?("/")
+              tar.mkdir(name, 0o755)
+            else
+              tar.add_file_simple(name, 0o644, content.bytesize) { |io| io.write(content) }
+            end
+          end
+        end
+      end
+      yield archive
+    end
+  end
+
+  def app_entries
+    {
+      "config/" => "",
+      "bin/" => "",
+      "config/application.rb" => "Rails.application\n",
+      "Gemfile" => "source 'https://rubygems.org'\n",
+      "bin/rails" => "#!/bin/sh\nexit 0\n"
+    }
+  end
+
+  def test_activates_a_valid_versioned_archive_atomically
+    with_xdg_home do
+      with_archive(app_entries) do |archive|
+        bundle = Hive::Web::AppBundle.new(
+          version: "9.9.9", source_dir: File.join(Hive::Paths.data_home, "no-source"), bundle_runner: ->(_dir) { true }
+        )
+        result = bundle.install_from_archive!(archive, expected_sha256: Digest::SHA256.file(archive).hexdigest)
+
+        assert result.ok?
+        assert_equal "installed", result.status
+        assert File.symlink?(bundle.current_path)
+        assert_equal bundle.current_dir, bundle.resolve
+        assert File.exist?(File.join(bundle.current_dir, Hive::Web::AppBundle::READY_FILE))
+      end
+    end
+  end
+
+  def test_rejects_traversal_before_touching_the_current_bundle
+    with_xdg_home do
+      bundle = Hive::Web::AppBundle.new(
+        version: "9.9.9", source_dir: File.join(Hive::Paths.data_home, "no-source"), bundle_runner: ->(_dir) { true }
+      )
+      FileUtils.mkdir_p(File.dirname(bundle.current_path))
+      stable = File.join(File.dirname(bundle.current_path), "stable")
+      FileUtils.mkdir_p(stable)
+      File.symlink(stable, bundle.current_path)
+
+      with_archive(app_entries.merge("../outside" => "nope")) do |archive|
+        result = bundle.install_from_archive!(archive, expected_sha256: Digest::SHA256.file(archive).hexdigest)
+
+        refute result.ok?
+        assert_equal "unsafe_archive", result.status
+        assert_equal stable, File.realpath(bundle.current_path)
+      end
+    end
+  end
+
+  def test_digest_mismatch_does_not_extract_or_switch_current
+    with_xdg_home do
+      with_archive(app_entries) do |archive|
+        bundle = Hive::Web::AppBundle.new(
+          version: "9.9.9", source_dir: File.join(Hive::Paths.data_home, "no-source"), bundle_runner: ->(_dir) { true }
+        )
+        result = bundle.install_from_archive!(archive, expected_sha256: "0" * 64)
+
+        refute result.ok?
+        assert_equal "digest_mismatch", result.status
+        refute File.exist?(bundle.current_path)
+      end
+    end
+  end
+
+  def test_source_tree_and_explicit_override_take_precedence
+    with_tmp_dir do |dir|
+      source = File.join(dir, "source")
+      FileUtils.mkdir_p(File.join(source, "config"))
+      File.write(File.join(source, "config/application.rb"), "Rails.application\n")
+      File.write(File.join(source, "Gemfile"), "source 'https://rubygems.org'\n")
+      FileUtils.mkdir_p(File.join(source, "bin"))
+      File.write(File.join(source, "bin/rails"), "#!/bin/sh\n")
+
+      bundle = Hive::Web::AppBundle.new(source_dir: source)
+      assert_equal source, bundle.resolve
+      with_env("HIVEBOX_WEB_APP_DIR" => source) { assert_equal source, bundle.resolve }
+    end
+  end
+end
diff --git a/test/unit/web/daemon_control_test.rb b/test/unit/web/daemon_control_test.rb
new file mode 100644
index 00000000..0e0a74aa
--- /dev/null
+++ b/test/unit/web/daemon_control_test.rb
@@ -0,0 +1,51 @@
+require "test_helper"
+require "hive/web/daemon_control"
+
+class HiveWebDaemonControlTest < Minitest::Test
+  include HiveTestHelper
+
+  FakeInstaller = Struct.new(:actions, :outcome) do
+    def control!(action)
+      actions << action
+      true
+    end
+
+    def lifecycle_status
+      { "status" => "running" }
+    end
+
+    def service_state
+      { "service_installed" => true, "service_enabled" => true, "unit_path" => "/tmp/hive-daemon" }
+    end
+
+    def configured_executable
+      "/opt/hive/bin/hive"
+    end
+
+    def install!(**_kwargs)
+      outcome
+    end
+  end
+
+  def test_start_uses_closed_action_set_and_preserves_current_binary
+    actions = []
+    binaries = []
+    fake = FakeInstaller.new(actions, nil)
+    with_replaced_singleton_method(Hive::Commands::Daemon::ServiceInstaller, :new, lambda { |**kwargs|
+      binaries << kwargs[:binary_path] if kwargs[:binary_path]
+      fake
+    }) do
+      result = Hive::Web::DaemonControl.new(binary_path: "/opt/hive/bin/hive").perform!("start")
+      assert_equal [ "start" ], actions
+      assert_equal "start", result.fetch("action")
+    end
+    assert_equal [ "/opt/hive/bin/hive" ], binaries
+  end
+
+  def test_rejects_command_text
+    error = assert_raises(ArgumentError) do
+      Hive::Web::DaemonControl.new(binary_path: "/opt/hive/bin/hive").perform!("restart; rm -rf /")
+    end
+    assert_match(/unsupported daemon maintenance action/, error.message)
+  end
+end
diff --git a/web/Gemfile b/web/Gemfile
index 53710d90..1e822c58 100644
--- a/web/Gemfile
+++ b/web/Gemfile
@@ -70,4 +70,11 @@ end
 # The hive control plane: status payloads, gate approval, daemon dispatch,
 # the GitHub device-flow gate, the agent OAuth relay, and Telegram
 # validation all come from the gem — the web tier adds no pipeline logic.
-gem "hive-cli", path: ".."
+# A source checkout uses the parent gem for contributor iteration. The
+# release archive intentionally has no parent checkout, so it resolves the
+# already-installed version-matched hive-cli gem instead.
+if File.file?(File.expand_path("../hive.gemspec", __dir__))
+  gem "hive-cli", path: ".."
+else
+  gem "hive-cli", ENV.fetch("HIVE_WEB_HIVE_VERSION", ">= 0")
+end
diff --git a/web/app/controllers/application_controller.rb b/web/app/controllers/application_controller.rb
index 2a1e5e28..81ef6757 100644
--- a/web/app/controllers/application_controller.rb
+++ b/web/app/controllers/application_controller.rb
@@ -1,4 +1,5 @@
 class ApplicationController < ActionController::Base
+  require "hive/web/loopback"
   # Rails 8 enables forgery protection by default; explicit so static
   # scanners (and readers) see the contract without chasing framework
   # defaults.
@@ -50,6 +51,15 @@ class ApplicationController < ActionController::Base
   end
 
   def require_login
+    return if Hive::Web::Loopback.trusted_request?(
+      enabled: ENV["HIVE_WEB_LOCAL_LOOPBACK"] == "1",
+      # REMOTE_ADDR is the socket peer supplied by Rack. Do not use
+      # `request.remote_ip` here: that convenience accessor intentionally
+      # considers X-Forwarded-For and would turn a spoofed header into an
+      # authentication input for a no-login local service.
+      remote_ip: request.get_header("REMOTE_ADDR"),
+      host: request.host
+    )
     return redirect_to login_path unless current_login
 
     # Sessions must track the CURRENT owner, not the owner at sign-in time:
diff --git a/web/app/controllers/daemon_controller.rb b/web/app/controllers/daemon_controller.rb
new file mode 100644
index 00000000..a4989664
--- /dev/null
+++ b/web/app/controllers/daemon_controller.rb
@@ -0,0 +1,39 @@
+require "digest"
+require "hive/web/daemon_control"
+
+class DaemonController < ApplicationController
+  def create
+    action = params.require(:action).to_s
+    unless MaintenanceOperation::ACTIONS.include?(action)
+      render json: { ok: false, error: "unsupported maintenance action" }, status: :unprocessable_entity
+      return
+    end
+
+    key = request.headers["Idempotency-Key"].presence || Digest::SHA256.hexdigest("#{current_login}:#{action}")
+    operation = MaintenanceOperation.find_or_create_by!(idempotency_key: key) do |record|
+      record.action = action
+      record.status = "queued"
+      record.requested_at = Time.current
+    end
+    DaemonMaintenanceJob.perform_later(operation.id) if operation.queued?
+
+    render json: operation_payload(operation), status: :accepted
+  end
+
+  def show
+    operation = MaintenanceOperation.find(params[:id])
+    render json: operation_payload(operation).merge("daemon" => Hive::Web::DaemonControl.new.status)
+  end
+
+  private
+
+  def operation_payload(operation)
+    {
+      ok: true,
+      operation_id: operation.id,
+      action: operation.action,
+      status: operation.status,
+      result: operation.result
+    }
+  end
+end
diff --git a/web/app/controllers/status_controller.rb b/web/app/controllers/status_controller.rb
index c44440a8..1e3ed530 100644
--- a/web/app/controllers/status_controller.rb
+++ b/web/app/controllers/status_controller.rb
@@ -2,5 +2,6 @@ class StatusController < ApplicationController
   def index
     @payload = StatusBroadcaster.snapshot
     @projects = @payload.fetch("projects", [])
+    @daemon_status = Hive::Web::DaemonControl.new.status
   end
 end
diff --git a/web/app/jobs/daemon_maintenance_job.rb b/web/app/jobs/daemon_maintenance_job.rb
new file mode 100644
index 00000000..fb37030d
--- /dev/null
+++ b/web/app/jobs/daemon_maintenance_job.rb
@@ -0,0 +1,49 @@
+require "fileutils"
+require "hive/paths"
+require "hive/web/daemon_control"
+require "json"
+
+# Runs only a typed DaemonControl operation. The row provides durable progress
+# across web restarts; the process-wide lock prevents two accepted repairs from
+# racing to rewrite the same per-user service definition.
+class DaemonMaintenanceJob < ApplicationJob
+  def perform(operation_id)
+    operation = MaintenanceOperation.find(operation_id)
+    return unless operation.queued?
+
+    operation.with_lock do
+      return unless operation.queued?
+
+      operation.update!(status: "running", started_at: Time.current)
+    end
+
+    result = nil
+    with_maintenance_lock do
+      result = Hive::Web::DaemonControl.new.perform!(operation.action)
+    end
+    operation.update!(status: "succeeded", finished_at: Time.current, result: redact(result))
+  rescue StandardError => error
+    operation&.update(status: "failed", finished_at: Time.current,
+                      result: { "error" => "#{error.class}: #{error.message.to_s[0, 240]}" })
+  end
+
+  private
+
+  def redact(value)
+    JSON.parse(JSON.generate(value).gsub(/(?:token|secret|password|api[_-]?key)\s*[=:]\s*[^\s,}]+/i, "[REDACTED]"))
+  end
+
+  def with_maintenance_lock
+    FileUtils.mkdir_p(Hive::Paths.state_home)
+    path = File.join(Hive::Paths.state_home, ".daemon-maintenance.lock")
+    File.open(path, File::RDWR | File::CREAT, 0o600) do |file|
+      deadline = Time.now + 30
+      until file.flock(File::LOCK_EX | File::LOCK_NB)
+        raise Hive::ConcurrentRunError.new("daemon maintenance lock timed out", lock_path: path) if Time.now >= deadline
+
+        sleep 0.1
+      end
+      yield
+    end
+  end
+end
diff --git a/web/app/models/maintenance_operation.rb b/web/app/models/maintenance_operation.rb
new file mode 100644
index 00000000..c53034d3
--- /dev/null
+++ b/web/app/models/maintenance_operation.rb
@@ -0,0 +1,12 @@
+class MaintenanceOperation < ApplicationRecord
+  ACTIONS = %w[start restart repair].freeze
+  STATUSES = %w[queued running succeeded failed].freeze
+
+  validates :action, inclusion: { in: ACTIONS }
+  validates :status, inclusion: { in: STATUSES }
+  validates :idempotency_key, presence: true, uniqueness: true
+
+  def queued?
+    status == "queued"
+  end
+end
diff --git a/web/app/views/status/_daemon.html.erb b/web/app/views/status/_daemon.html.erb
new file mode 100644
index 00000000..e4c32caa
--- /dev/null
+++ b/web/app/views/status/_daemon.html.erb
@@ -0,0 +1,15 @@
+<section class="daemon-status" aria-label="Daemon health">
+  <h2>Daemon</h2>
+  <p>
+    <strong><%= daemon.fetch("running") ? "running" : "stopped" %></strong>
+    <% if daemon["drift"] && daemon["drift"] != "none" %>
+      — <%= daemon.fetch("drift") %> drift
+    <% end %>
+  </p>
+  <% if daemon["recommended_action"] %>
+    <p><code><%= daemon.fetch("recommended_action") %></code></p>
+  <% end %>
+  <%= button_to "Start", daemon_maintenance_path, params: { action: "start" }, form: { data: { turbo: true } } unless daemon.fetch("running") %>
+  <%= button_to "Restart", daemon_maintenance_path, params: { action: "restart" }, form: { data: { turbo: true } } if daemon.fetch("running") %>
+  <%= button_to "Repair service", daemon_maintenance_path, params: { action: "repair" }, form: { data: { turbo: true } } if %w[path version unparseable].include?(daemon["drift"]) %>
+</section>
diff --git a/web/app/views/status/index.html.erb b/web/app/views/status/index.html.erb
index 25bcdf79..87b076dc 100644
--- a/web/app/views/status/index.html.erb
+++ b/web/app/views/status/index.html.erb
@@ -66,6 +66,8 @@
   </div>
 <% end %>
 
+<%= render "status/daemon", daemon: @daemon_status %>
+
 <%= render "status/projects", projects: @projects %>
   </div>
 </div>
diff --git a/web/config/environments/production.rb b/web/config/environments/production.rb
index b991b661..07fb7196 100644
--- a/web/config/environments/production.rb
+++ b/web/config/environments/production.rb
@@ -89,7 +89,10 @@ Rails.application.configure do
   # ]
   #
   # Skip DNS rebinding protection for the default health check endpoint.
-  # config.host_authorization = { exclude: ->(request) { request.path == "/up" } }
+  if ENV["HIVE_WEB_LOCAL_LOOPBACK"] == "1"
+    config.hosts = [ "localhost", "127.0.0.1", "::1" ]
+  end
+  config.host_authorization = { exclude: ->(request) { request.path == "/up" } }
 
   # Turbo Streams connect over Action Cable. Same-origin-as-host covers the
   # normal case with ZERO config — browse the box at any address and the
diff --git a/web/config/initializers/hive.rb b/web/config/initializers/hive.rb
index f2792b55..64e6e3f1 100644
--- a/web/config/initializers/hive.rb
+++ b/web/config/initializers/hive.rb
@@ -8,5 +8,6 @@ require "hive/web/dispatcher"
 require "hive/web/agents_auth"
 require "hive/web/telegram_validator"
 require "hive/web/telegram_tester"
+require "hive/web/daemon_control"
 require "hive/commands/init"
 require "hive/commands/approve"
diff --git a/web/config/routes.rb b/web/config/routes.rb
index 659576df..dfa015c2 100644
--- a/web/config/routes.rb
+++ b/web/config/routes.rb
@@ -17,6 +17,9 @@ Rails.application.routes.draw do
 
   root "status#index"
 
+  post "daemon/maintenance" => "daemon#create", as: :daemon_maintenance
+  get "daemon/maintenance/:id" => "daemon#show", as: :daemon_maintenance_operation
+
   post "ideas" => "ideas#create", as: :ideas
 
   # Task pages are addressed by project name + task slug, mirroring the CLI.
diff --git a/web/db/migrate/20260723000000_create_maintenance_operations.rb b/web/db/migrate/20260723000000_create_maintenance_operations.rb
new file mode 100644
index 00000000..f7606df9
--- /dev/null
+++ b/web/db/migrate/20260723000000_create_maintenance_operations.rb
@@ -0,0 +1,15 @@
+class CreateMaintenanceOperations < ActiveRecord::Migration[8.1]
+  def change
+    create_table :maintenance_operations do |t|
+      t.string :action, null: false
+      t.string :status, null: false
+      t.string :idempotency_key, null: false
+      t.json :result
+      t.datetime :requested_at, null: false
+      t.datetime :started_at
+      t.datetime :finished_at
+      t.timestamps
+    end
+    add_index :maintenance_operations, :idempotency_key, unique: true
+  end
+end
